import _ from 'lodash'

/**
 * 前端公式 计算精确天数
 * 公式说明 根据首日是否凌晨入住及尾日是否延迟退房来计算两个日期的精确间隔天数
 * @author fengjiansheng
 * @data 2021-08-27
 * @update 2021-09-01
 */
export default {
    execute: function () {
        console.log("s1 GetExactDays")
        if (arguments && arguments[0] && arguments[0][0] && arguments[0][1]) {
            let date1 = arguments[0][0].getResult().Value
            let date2 = arguments[0][1].getResult().Value
            let isCheckInOnFirstDayEarliest
            let isCheckOutOnLastDayLatest
            if (arguments[0].length === 2) {
                isCheckInOnFirstDayEarliest = '0'
            }else{
                isCheckInOnFirstDayEarliest = arguments[0][2].getResult().Value
            }
            if (arguments[0].length === 3) {
                isCheckOutOnLastDayLatest = '0'
            }else{
                isCheckOutOnLastDayLatest = arguments[0][3].getResult().Value
            }
            let days = Math.abs(parseInt((date2 - date1) / (1000 * 60 * 60 * 24)))
            if (date1 && date2 && date2 >= date1) {
                if (days === 0) {
                    return 1
                }
                if (!_.isEmpty(isCheckInOnFirstDayEarliest) && isCheckInOnFirstDayEarliest === "1") {
                    days += 1
                }
                if (!_.isEmpty(isCheckOutOnLastDayLatest) && isCheckOutOnLastDayLatest === "1") {
                    days += 1
                }
                return days;
            } else {
                return null
            }
        }
    },
    getResultType: function () {
        return FMR.ConstDataTypes.General;
    }
}
